package com.yaohun.farmingwar.manager;

import com.io.yutian.mclive.event.ZhuboAPI;
import com.yaohun.farmingwar.data.GiftData;
import com.yaohun.farmingwar.data.LikeData;
import org.bukkit.Bukkit;
import org.bukkit.configuration.ConfigurationSection;
import org.bukkit.configuration.file.FileConfiguration;
import org.bukkit.configuration.file.YamlConfiguration;

import java.io.File;
import java.util.ArrayList;
import java.util.HashMap;

public class GameManager {

    private static boolean isRandomBox;
    private HashMap<String, LikeData> likeDataMap = new HashMap<>();
    private HashMap<String, GiftData> giftDataMap = new HashMap<>();

    public GameManager(){
        Bukkit.getConsoleSender().sendMessage("[日志 - 保卫小麦] 工具注册:");
        loadRandomBoxPlugin();
        Bukkit.getConsoleSender().sendMessage("[日志 - 保卫小麦] 事件注册:");
        File file = new File("./plugins/游戏设置","礼物设置.yml");
        FileConfiguration gift_yml = YamlConfiguration.loadConfiguration(file);
        ConfigurationSection likeSection = gift_yml.getConfigurationSection("点赞整蛊");
        if (likeSection != null) {
            for (String key : likeSection.getKeys(false)) {
                String effect = likeSection.getString(key+".效果");
                int likeAmount = likeSection.getInt(key+".点赞次数");
                likeDataMap.put(effect,new LikeData(effect,likeAmount));
                String message = "事件: "+effect+"   条件: 点赞x"+likeAmount;
                Bukkit.getConsoleSender().sendMessage(message);
            }
        }
        ConfigurationSection giftSection = gift_yml.getConfigurationSection("礼物设置");
        if(giftSection != null){
            ZhuboAPI.setGameGiftList(new ArrayList<>(giftSection.getKeys(false)));
            for (String giftName : giftSection.getKeys(false)) {
                giftDataMap.put(giftName, new GiftData(giftName, gift_yml));
            }
        }
    }

    public void loadRandomBoxPlugin() {
        if(Bukkit.getPluginManager().getPlugin("RandomBox") != null){
            isRandomBox = true;
            Bukkit.getConsoleSender().sendMessage("- 随机盲盒: 已启用");
        } else {
            isRandomBox = false;
            Bukkit.getConsoleSender().sendMessage("- 随机盲盒: 未启用");
        }
    }


    public static boolean isIsRandomBox() {
        return isRandomBox;
    }
    // 判断哪个点赞整蛊效果已达到要求可触发
    public HashMap<String, LikeData> getLikeDataMap() {
        return likeDataMap;
    }
    public boolean isGiftDataExit(String giftName){
        for (String gift : this.giftDataMap.keySet()){
            if(gift.equalsIgnoreCase(giftName)){
                return true;
            }
        }
        return false;
    }
    public GiftData getGiftData(String giftName){
        if(this.giftDataMap.get(giftName) == null){
            return null;
        }
        return this.giftDataMap.get(giftName);
    }
    public HashMap<String, GiftData> getGiftDataMap() {
        return giftDataMap;
    }
}
